Program CampoMagnetico;                       {Carlos Gershenson}

Uses
	Graph,crt;


Var

     grDriver: Integer;
     grMode: Integer;
     ErrCode: Integer;
     f,CM:real;
     x,y,xa:real;

function IntToStr(I: real): String;
var
 S: string[30];
begin
 Str(I:20:6, S);
 IntToStr := S;
end;

Procedure Check(var CH:real);

var
  res:integer;

begin
  Repeat
  {$I-}
    readln(CH);
    res:=IOresult;
  {$I+}
  if res<>0 then
  begin
    writeln('Error,trate de nuevo');
  end;
  Until res=0;
end;

Procedure helice(a,b:real);
var
   t:longint;

Begin
    for t:=0 to round((1/b)*25000) do
    begin
      xa:=x;
      x:=a*SIN(t/50)-a*COS(t/50);
      y:=-(a*SIN(t/50)/2)-(a*COS(t/50)-2)+b*t/50;
      If (round(x)+300<304)and(round(x)+300>296)and(xa>x) then
      else
        putpixel(round(y)+50,round(x)+300,lightred);
    end;
End;

Procedure Campo;
Begin
     f:=abs(CM)*1758819617*100/(2*pi);
     SetColor(lightblue);
     OutTextXY(100,80,'Campo Magntico: ');
     OutTextXY(240,80,IntToStr(CM));
     OutTextXY(410,80,'Teslas');
     OutTextXY(100,100,'Frecuencia: ');
     OutTextXY(240,100,IntToStr(f));
     OutTextXY(410,100,'Hertz');
     SetColor(lightgray);
     SetFillStyle(1,lightgray);
     bar(30,297,600,303);
     Fillellipse(30,300,3,3);
     SetFillStyle(1,darkgray);
     SetColor(darkgray);
     Fillellipse(600,300,3,3);
     helice(30,f/1000000000);
     readln;
End;

Begin
     Writeln('                 CAMPO MAGNTICO DE UN CABLE');
     Writeln('                      CARLOS GERSHENSON');
     Writeln;Writeln;
     Write('Dame el Campo Magntico del cable en Teslas: ');
     check(CM);
     grDriver := Detect;
     InitGraph(grDriver, grMode,' ');
     ErrCode := GraphResult;
     if ErrCode = grOk then
     begin
       Campo;
       CloseGraph;
     end
 	else
   		Writeln('Graphics error:', GraphErrorMsg(ErrCode));
End.
