Program fractal3D;                       {Carlos Gershenson}

Uses
	Graph,crt;
Var
     m,color:byte;
     res,grDriver: Integer;
     grMode: Integer;
     ErrCode: Integer;

Procedure Generador(x1,y1,x2,y2,x3,y3,x4,y4,x5,y5:integer);
Begin
       Line(x1,y1,x2,y2);
       Line(x2,y2,x3,y3);
       Line(x3,y3,x1,y1);
       Line(x1,y1,x4,y4);
       Line(x1,y1,x5,y5);
       Line(x4,y4,x5,y5);
       Line(x2,y2,x4,y4);
       Line(x3,y3,x5,y5);

End;

Procedure Fract(x1,y1,x2,y2,x3,y3,x4,y4,x5,y5,n:integer);
var
   v1,w1,v2,w2,v3,w3,v4,w4,v5,w5,s1,s2,s3,s4,t1,t2,t3,t4:integer;
Begin
       v1:=abs((x5-x2) div 2 +x2);
       w1:=abs((y5-y2) div 2 +y2);
       v2:=abs((x1-x2) div 2 +x2);
       w2:=abs((y1-y2) div 2 +y2);
       v3:=abs((x1-x3) div 2 +x3);
       w3:=abs((y1-y3) div 2 +y3);
       v4:=abs((x1-x4) div 2 +x4);
       w4:=abs((y1-y4) div 2 +y4);
       v5:=abs((x1-x5) div 2 +x5);
       w5:=abs((y1-y5) div 2 +y5);
       s1:=abs((x3-x2) div 2 +x2);
       t1:=abs((y3-y2) div 2 +y2);
       s2:=abs((x5-x3) div 2 +x3);
       t2:=abs((y5-y3) div 2 +y3);
       s3:=abs((x5-x4) div 2 +x4);
       t3:=abs((y5-y4) div 2 +y4);
       s4:=abs((x4-x2) div 2 +x2);
       t4:=abs((y4-y2) div 2 +y2);
       repeat
         color:=random(16);
       until color mod 2<>0;
       setcolor(color);
       dec(n);
       Generador(v1,w1,v2,w2,v3,w3,v4,w4,v5,w5);
       If n>0 then
	begin
	 fract(v5,w5,v1,w1,s2,t2,s3,t3,x5,y5,n);
         fract(v4,w4,s4,t4,v1,w1,x4,y4,s3,t3,n);
         fract(v3,w3,s1,t1,x3,y3,v1,w1,s2,t2,n);
         fract(v2,w2,x2,y2,s1,t1,s4,t4,v1,w1,n);
         fract(x1,y1,v2,w2,v3,w3,v4,w4,v5,w5,n);

	end;
End;
Begin
     write('Cuntas iteraciones desea usted? ');
     Repeat
     {$I-}
       readln(m);
       res:=IOresult;
     {$I+}
     if res<>0 then
       writeln('Error,trate de nuevo');
     Until res=0;
     Randomize;
     grDriver := Detect;
     InitGraph(grDriver, grMode,' ');
     ErrCode := GraphResult;
     if ErrCode = grOk then
     begin
          repeat
            color:=random(16);
          until color mod 2<>0;
          setcolor(color);
          Generador(getmaxx div 2,0,0,getmaxy,getmaxx-200,getmaxy,200,getmaxy-200,getmaxx,getmaxy-200);
          Fract(getmaxx div 2,0,0,getmaxy,getmaxx-200,getmaxy,200,getmaxy-200,getmaxx,getmaxy-200,m);
       readln;
       CloseGraph;
     end
	else
		Writeln('Graphics error:', GraphErrorMsg(ErrCode));
End.
