Program Fractal;                       {Carlos Gershenson}

Uses
	Graph,crt;

Type
     Coord=array [1..10] of integer;
Var
     grDriver: Integer;
     grMode: Integer;
     ErrCode: Integer;
     N,m:coord;
     color:integer;

Procedure Fract(var n:coord);
Begin
     If color < 30 then
     begin
      SetColor(color);
      Line(n[1],n[2],n[3],n[4]);
      Line(n[3],n[4],n[5],n[6]);
      Line(n[5],n[6],n[7],n[8]);
      Line(n[7],n[8],n[9],n[10]);
      Line(n[9],n[10],n[1],n[2]);

       m[1]:=abs((n[3]-n[1]) div 2 +n[1]);
       m[2]:=abs((n[4]-n[2]) div 2 +n[2]);
       m[3]:=abs((n[5]-n[3]) div 2 +n[3]);
       m[4]:=abs((n[6]-n[4]) div 2 +n[4]);
       m[5]:=abs((n[7]-n[5]) div 2 +n[5]);
       m[6]:=abs((n[8]-n[6]) div 2 +n[6]);
       m[7]:=abs((n[9]-n[7]) div 2 +n[7]);
       m[8]:=abs((n[10]-n[8]) div 2 +n[8]);
       m[9]:=abs((n[1]-n[9]) div 2 +n[9]);
       m[10]:=abs((n[2]-n[10]) div 2 +n[10]);

       n:=m;

      inc(color);
      If color mod 8=0 then
      inc(color);
      delay(200);
      Fract(n);
     end;
End;

Begin
	grDriver := Detect;
     InitGraph(grDriver, grMode,' ');
     ErrCode := GraphResult;
     if ErrCode = grOk then
     begin
       color:=1;
       n[1]:=105;
       n[2]:=5;
       n[3]:=305;
       n[4]:=5;
       n[5]:=405;
       n[6]:=305;
       n[7]:=205;
       n[8]:=405;
       n[9]:=5;
       n[10]:=305;
       Fract(n);
       readln;
      CloseGraph;
     end
     else
        Writeln('Graphics error:', GraphErrorMsg(ErrCode));
End.
