Program fractal3;                       {Carlos Gershenson}

Uses
	Graph,crt;
Var

     grDriver: Integer;
     grMode: Integer;
     ErrCode: Integer;

Procedure Generador(x1,y1,x2,y2,x3,y3:integer);
Begin
       Line(x1,y1,x2,y2);
       Line(x2,y2,x3,y3);
       Line(x3,y3,x1,y1);
End;

Procedure Fract(x1,y1,x2,y2,x3,y3,n:integer);
var
   v1,w1,v2,w2,v3,w3:integer;
Begin
       v1:=abs((x2-x1) div 2 +x1);
       w1:=abs((y2-y1) div 2 +y1);
       v2:=abs((x3-x2) div 2 +x2);
       w2:=abs((y3-y2) div 2 +y2);
       v3:=abs((x1-x3) div 2 +x3);
       w3:=abs((y1-y3) div 2 +y3);
       setcolor(Random(16));
       dec(n);
       Generador(v1,w1,v2,w2,v3,w3);
       If n>0 then
	begin
	 fract(v3,w3,v2,w2,x3,y3,n);
	 fract(x1,y1,v1,w1,v3,w3,n);
	 fract(v1,w1,x2,y2,v2,w2,n);
	end;
End;
Begin
     grDriver := Detect;
     InitGraph(grDriver, grMode,' ');
     ErrCode := GraphResult;
     if ErrCode = grOk then
     begin
	  Generador(getmaxx div 2,0,getmaxx,getmaxy,0,getmaxy);
	  Fract(getmaxx div 2,0,getmaxx,getmaxy,0,getmaxy,8);
       readln;
       CloseGraph;
     end
	else
		Writeln('Graphics error:', GraphErrorMsg(ErrCode));
End.
